--
-- IndoorHudExtended
--
-- @author:    	Xentro (Marcus@Xentro.se)
-- @website:	www.Xentro.se
-- @history:	v1.0 - 2016-07-14 - Initial implementation
-- 
--[[
<indoorHud>
	<extended name="" numbers="" precision="1" />
</indoorHud>
]]--

IndoorHudExtended = {};

function IndoorHudExtended.prerequisitesPresent(specializations)
    if not SpecializationUtil.hasSpecialization(IndoorHud, specializations) then print("Warning: Specialization IndoorHudExtended needs the specialization IndoorHud."); end;
	
	return SpecializationUtil.hasSpecialization(IndoorHud, specializations);
end;

function IndoorHudExtended:load(xmlFile)
	self.indoorHudExtended = {};
	local i = 0;
	while true do
		local nameString = string.format("extended(%d)", i);
		local key = "vehicle.indoorHud." .. nameString;
		if not hasXMLProperty(xmlFile, key) then break; end;
		
		local name = getXMLString(xmlFile, key .. "#name");
		if name ~= nil and name ~= "" then
			if self[name] ~= nil then
				local entry = {};
				entry.name = name;
				entry.animMax = Utils.getNoNil(getXMLInt(xmlFile, key .. "#animMax"), 9999);
				entry.hud = IndoorHud.loadValue(self, xmlFile, nameString);
				
				if entry.hud ~= nil then
					table.insert(self.indoorHudExtended, entry);
				end;
			else
				print("IndoorHudExtended - Error: Variable self." .. name .. " is invalid.");
				break;
			end;
		end;
		
		i = i + 1;
	end;
end;

function IndoorHudExtended:delete()
end;

function IndoorHudExtended:readStream(streamId, connection)
end;

function IndoorHudExtended:writeStream(streamId, connection)
end;

function IndoorHudExtended:mouseEvent(posX, posY, isDown, isUp, button)
end;

function IndoorHudExtended:keyEvent(unicode, sym, modifier, isDown)
end;

function IndoorHudExtended:update(dt)
end;

function IndoorHudExtended:updateTick(dt)
	if self:getIsActive() then
		for i, v in ipairs(self.indoorHudExtended) do
			local variable = self[v.name];
			if variable ~= nil then
				self:setHudValue(v.hud, variable, v.animMax);
			end;
		end;
	end;
end;

function IndoorHudExtended:draw()
end;